            #GIT_CMT=5c65caa6245a109fd59c3a9a244c7f10d4a5d479
#
# spec file for package Oracle Linux Storage Appliance
#
%define lsa_oldname linux-nfs-storage-manager
%define lsa_name linux-storage-manager
%define lsa_version 1.8.1

Name:	%{lsa_name}
Version:	%{lsa_version}
Release:    0.el7
Summary:	Oracle Linux Storage Appliance

Group:		Applications/System
Obsoletes:  %{lsa_oldname}
Provides:   %{lsa_oldname}
Conflicts:  %{lsa_oldname}
License:    The Universal Permissive License (UPL), Version 1.0
Vendor:     Oracle America
Source0: linux-storage-manager-1.8.1.tar.bz2
BuildRoot:  %{_builddir}/%{name}-root

BuildRequires:	python
BuildRequires: systemd
BuildRequires: python2-devel
Requires:   python
Requires:   python-flask
Requires:   python2-flask-login
Requires:   python2-psutil
Requires:   python-pam
Requires:   python-setuptools
Requires:   python36-oci-cli
Requires:   python-oci-sdk
Requires:   httpd
Requires:   mdadm
Requires:   util-linux
Requires:   nfs-utils
Requires:   net-tools
Requires:   xfsprogs
Requires:   xfsdump
Requires:   pexpect
Requires:   mod_wsgi
Requires:   mod_ssl
Requires:   openssl
Requires:   policycoreutils-python
Requires:   yum-plugin-security
Requires:   gcc
Requires:   libffi-devel
Requires:   python-devel
Requires:   openssl-devel
Requires:   samba
Requires:   samba-winbind
Requires:   realmd
Requires:   oddjob-mkhomedir
Requires:   oddjob
Requires:   samba-winbind-clients
Requires:   samba-common-tools
Requires:   samba-winbind-krb5-locator
Requires:   oci-utils >= 0.6-34
Requires:   util-linux
BuildArch:  noarch

%description
A web-based software appliance to manage shared storage

%prep
%setup -q

%build
make expand


%install
%{__mkdir_p} $RPM_BUILD_ROOT/opt/lsa
%{__cp} -rp backend webapp %{buildroot}/opt/lsa
%{__mkdir} %{buildroot}/opt/lsa/webapp/logs
%{__mkdir} %{buildroot}/opt/lsa/var
%{__mkdir_p} %{buildroot}/var/opt/lsa/

%{__mkdir_p} %{buildroot}%{_unitdir}
%{__mv} %{buildroot}/opt/lsa/backend/init/config-lsa.service %{buildroot}%{_unitdir}
%{__mv} %{buildroot}/opt/lsa/backend/init/storage-pool-import.service %{buildroot}%{_unitdir}
%{__mv} %{buildroot}/opt/lsa/webapp/apache/webapp-priv-exec.service %{buildroot}%{_unitdir}

%{__mkdir_p} %{buildroot}%{_sysctldir}
%{__mv} %{buildroot}/opt/lsa/backend/init/lsa-boot-on-panic-hang.conf %{buildroot}%{_sysctldir}
%{__mv} %{buildroot}/opt/lsa/backend/init/nfs-v3-lockd-port.conf %{buildroot}%{_sysctldir}

%{__mkdir_p} %{buildroot}/etc/httpd/conf.d/
%{__mv} %{buildroot}/opt/lsa/webapp/apache/httpd.conf %{buildroot}/etc/httpd/conf.d/lsa.conf

%{__mkdir_p} %{buildroot}/etc/firewalld/services/
%{__mv} -v %{buildroot}/opt/lsa/webapp/apache/webapp-lsa.xml %{buildroot}/etc/firewalld/services/webapp-lsa.xml


%{__mkdir_p} %{buildroot}/etc/systemd/journald.conf.d/
%{__mv} -v %{buildroot}/opt/lsa/backend/init/lsa-journald.conf %{buildroot}/etc/systemd/journald.conf.d/00-lsa-journald.conf

%{__mkdir_p} %{buildroot}%{_presetdir}
%{__mv} %{buildroot}/opt/lsa/backend/init/lsa.preset %{buildroot}%{_presetdir}/60-lsa.preset

%{__python2}  -m compileall %{buildroot}/opt/lsa/backend/

exit 0

%clean
rm -rf $RPM_BUILD_ROOT

%pre
# We support only update of existing LSA package or installation
# while building the OCI image.
if [ "$1" == "2" ]; then
    # upgrade
    RPM_VERSION=`/bin/rpm -q --queryformat='%%{VERSION}' %{lsa_name} 2>&1`
    # we remove any dot and keep only the first 2 digits
    # 1.6.6 -> 16
    # 1.6   -> 16
    # 1     -> 1
    _major_version=`echo $RPM_VERSION | /bin/awk '{gsub ( /[.]/,"") ; print substr($0,0,2) }'`
    # any version prior to 1.7.0 are not compatible
    if [ ${_major_version} -le 16 ]
    then
	echo 'cannot update from version prior to 1.7.0 due to filesystem incompatibility'
	exit 1
    fi
else
 # install
  if [ -z "${__LSA_FORCE_INSTALL_MODE}" ]
  then
	echo 'Linux storage appliance software cannot be installed manually'
	exit 1
  fi
fi


%post
%systemd_post config-lsa.service
%systemd_post storage-pool-import.service
%systemd_post webapp-priv-exec.service
# now take care of other service enablement
# we cannot use preset-all as cloud-init do not support that
# this would disable it
%systemd_post  httpd.service firewalld.service nfs-server.service nfs-mountd.service ocid.service smb.service nmb.service

%preun
%systemd_preun webapp-priv-exec.service
%systemd_preun storage-pool-import.service
%systemd_preun config-lsa.service
%systemd_preun httpd.service
if [ "$1" == "0" ]; then
    # uninstall
    # remove tag added at the end of config-lsa.service
    %{__rm} -f /var/opt/lsa/.state
    /opt/lsa/backend/init/uninstall.sh
fi

%postun
%systemd_postun_with_restart webapp-priv-exec.service storage-pool-import.service config-lsa.service httpd.service
%systemd_postun


%files
%defattr(-,root,root,-)
/opt/lsa
%attr(-, apache, apache) /opt/lsa/webapp/logs
%attr(544, root,root) /opt/lsa/backend/init/config_lsa_main.sh
%attr(544, root,root) /opt/lsa/backend/init/pool_conf_main.sh
%attr(544, root,root) /opt/lsa/backend/init/create_pool.sh
%attr(555, root,root) /opt/lsa/backend/init/state.sh
%attr(555, root,root) /opt/lsa/backend/init/install.sh
%{_unitdir}/config-lsa.service
%{_unitdir}/storage-pool-import.service
%{_unitdir}/webapp-priv-exec.service
%{_sysctldir}/nfs-v3-lockd-port.conf
%{_sysctldir}/lsa-boot-on-panic-hang.conf
%{_presetdir}/60-lsa.preset
/etc/httpd/conf.d/lsa.conf
/etc/firewalld/services/webapp-lsa.xml
/etc/systemd/journald.conf.d/00-lsa-journald.conf
/var/opt/lsa/

%changelog
* Thu Feb 20 2020 Oracle Public Cloud User <opc@lsa-dev-erwann-feb-2020.webad2iad.osdevelopmeniad.oraclevcn.com> - 1.8.1-0.el7
- update to support OL7u7 (Jan 2020) updated apache and smb configuration to
  address potential vulnerabilities detected by nessus bumped version

* Thu Jan 13 2020 Erwann Chenede <erwann.chenede@oracle.com> 1.8.1
- updated python-oci-cli to python36-oci-cli
* Tue Oct 9 2018 Erwann Chenede <erwann.chenede@oracle.com> 1.8
- Added support for Active Directory for SMB exports
- Fix for: timeout when filtering logs
- Fix for: pool usage gauge not updated
- Fix for: inconsistent share backup time
- Fix for: Storage pool accepts a previously used bv without any LSA vg 
- Fix for: Appliance tab time reporting issues
* Wed Jun 27 2018 Erwann Chenede <erwann.chenede@oracle.com> 1.7.1
- Fix for: wrong text for nfs export nohide option
- Fix for: inode32 seems modifiable but actually not
- Fix for: Don't show volume blocks with physical volumes as available
* Wed Jun 13 2018 Erwann Chenede <erwann.chenede@oracle.com> 1.7
- Added support for storage migration between instances
- Added support for OCI dynamic groups
- Enhanced error handling robustness
- Added Mount Information dialog
- Added OCI specific information in the appliance page
* Mon May 14 2018 Erwann Chenede <erwann.chenede@oracle.com> 1.6.1
- Addressed UI rendering issues on IE11
- Added sync options for SMB exports
- Updated UI to JET 5.0.0
- Updated to support OL 7.5
* Sat Mar 31 2018 Erwann Chenede <erwann.chenede@oracle.com> 1.6
- Added support for block volumes
